Graphics 640, 480, 32, 2

Text 250, 20, "Lade Graphiken"
Dim Map(15,20)

Dim imgP(360)
imgP(0) = CreateImage(32,32)
	SetBuffer ImageBuffer(imgP(0))
	Color 24,74,200
	Rect 0,22,10,3
	Rect 5,20,5,7
	Color 200,50,50
	Oval 9,19,15,9
	Oval 14,2,10,28
	Color 220,220,220
	Rect 24,6,10,22
	For I = 0 To 6
		Color 20+(I*5),20+(I*10),20+(I*10)
		Oval 8+I,8+I,16-(I*2),16-(I*2)
	Next
	MidHandle imgP(0)
	For I = 1 To 360
		imgP(I) = CopyImage(imgP(0))
		RotateImage imgP(I), I
	Next
	
Dim imgG(360)
imgG(0) = CreateImage(32, 32)
	SetBuffer ImageBuffer(imgG(0))
	MidHandle imgG(0)
	For I = 0 To 10
		Color 75+(I*5), 29+(I*5), 191+(I*5)
		Oval 2+I, 2+I, 28-(I*2), 28-(I*2)
	Next
	Color 220, 220, 220
	Oval 6, 4, 8, 8
	Oval 6, 19, 8, 8
	Color 50, 50, 50
	Oval 6, 7, 3, 3
	Oval 6, 22, 3, 3
	For I = 1 To 360
		imgG(I) = CopyImage(imgG(0))
		RotateImage imgG(I), I
	Next

Dim imgF(2)
imgF(0) = CreateImage(32,32)
	SetBuffer ImageBuffer(imgF(0))
	Color 9, 188, 0
	Rect 0, 0, 32, 32
	Color 5, 111, 0
	Rect 0, 0, 16, 16
	Rect 16,16,16,16
imgF(1) = CreateImage(32,32)
	SetBuffer ImageBuffer(imgF(1))
	MidHandle imgF(1)
	Color 200, 200, 200
	Rect 0,0,32,32
	Color 180, 180, 180
	Rect 5,5,22,22

Global imgL = CreateImage(200,200)
	SetBuffer ImageBuffer(imgL)
	Color 1,1,1
	Rect 0,0,200,200
	Color 0,0,0
	Oval 0,0,200,200

Global MX, MY, MH, MH2
Global Mp = 0, Mn = 1, Gp = 0, Ep = 0, Gt = 0, Gt2 = 100000
Global B[4]
Global E = 0, C = 0, S = 0
Global TT = 1000, T = 0, ITT = 20000, IT=0
Global PX# = 320, PY#=240, PW=90, PS#
Global PA = 0, PZ = 0, PZA = 1, PL# = 100
Type Ghosts
	Field X#, Y#
	Field W#[3]
	Field SS#, S#
	Field Entf, Range
	Field Typ
	Field Time, T
	Field Leben#
	Field Attaced
	Field BX[5], BY[5], BT[5], BTT[5], BW[5], BH[5]
End Type
Type Bloecke
	Field X, Y
End Type
Type Items
	Field X,Y,Typ[1]
End Type
	
HidePointer
SetBuffer BackBuffer()

Global Startzeit, Schleifenzeit

Repeat
	Startzeit = MilliSecs()
	Cls
	MX = MouseX()
	MY = MouseY()
	MH = MouseHit(1)
	MH2= MouseHit(2)
	
	TileImage imgF(0), 0, 0
	For Bl.Bloecke = Each Bloecke
		DrawImage imgF(1),Bl\X, Bl\Y
	Next
	
	If Mp > 0 Then
		moveGhost()
		Coll()
		Extras()
		movePlayer()
		
		If Gp > 0 Then Games()
		If Mp = 3 Then Credits()
		If Ep > 0 Then
			If Ep = 1 And E = 0 Then
				For Bl.Bloecke = Each Bloecke
					Delete Bl
				Next
				loadMap()
				E = 1
			EndIf
			If Ep = 3 Then
				S = S+1
				Ep = 0
			EndIf
		EndIf
		
		If KeyHit(1) Or PL < 0 Or Gt2 < 0 Then
			If Gp = 1 Then Gt = Gt/1000
			B[Gp] = Gt
			Mp = 0
			Gp = 0
			Ep = 0
			PL = 100
			Mp = 0
			For G.Ghosts = Each Ghosts
				Delete G
			Next
			C = 0
			Gt = 0
			Gt2 = 100000
		EndIf
	EndIf
	
	Menue()
	Color 255, 255,255
	
	Flip
	Schleifenzeit = MilliSecs() - Startzeit
Until Mp = 4


Function berechneWinkel(PlX, PlY, ObjX, ObjY)
	Local W
	W = (ATan2(PlY-ObjY, PlX-ObjX)+360) Mod 360
	
	Return W
End Function

Function berechneEntf(StX, StY, ZiX, ZiY, W)
	Return Sqr((ZiX-StX)^2+(ZiY-StY)^2)
End Function

Function erstelleGhost()
	G.Ghosts = New Ghosts
	G\X = Rnd(50, 500)
	G\Y = Rnd(50, 400)
	G\SS = Rnd(-0.5, -1)
	G\S = G\SS
	G\Leben = 100
	G\Attaced = 0
	For I = 0 To 4
		G\BTT[I] = Rand(300, 1000)
		G\BT[I] = 0
	Next
End Function

Function loadMap()
	If E = 0 Then
		For Bl.Bloecke = Each Bloecke
			Delete Bl
		Next
		Restore arena
		For I = 0 To 14
			For J = 0 To 19
				Read Map(I,J)
				If Map(I,J) Then
					Bl.Bloecke = New Bloecke
					Bl\X = J*32+16
					Bl\Y = I*32+16
				EndIf
			Next
		Next
	EndIf
End Function

Function Coll()
	For Bl.Bloecke = Each Bloecke
		For G.Ghosts = Each Ghosts
			If ImagesOverlap(imgG(0), G\X, G\Y, imgF(1), Bl\X, Bl\Y) Then
				If G\X<Bl\X Then G\X = G\X - 3
				If G\X>Bl\X Then G\X = G\X + 3
				If G\Y<Bl\Y Then G\Y = G\Y - 3
				If G\Y>Bl\Y Then G\Y = G\Y + 3
				If G\Entf > 100 Then G\T = 3000
			EndIf
		Next
		If ImagesOverlap(imgP(0), PX, PY, imgF(1), Bl\X, Bl\Y) Then
			If PX<Bl\X Then PX = PX - 3
			If PX>Bl\X Then PX = PX + 3
			If PY<Bl\Y Then PY = PY - 3
			If PY>Bl\Y Then PY = PY + 3
		EndIf
	Next
End Function

Function movePlayer()
	If KeyDown(57) Then PA = 1
	If KeyDown(57) = 0 Then PA = 0
	If PA = 0 Then
		If KeyDown(200) Then PS = -1.4
		If KeyDown(208) Then PS = 1.4
		If KeyDown(208) = 0 And KeyDown(200) = 0 Then PS = 0
		If KeyDown(203) Then PW = PW - 3
		If KeyDown(205) Then PW = PW + 3
	EndIf
	If PW < 0 Then PW = 360
	If PW > 360 Then PW = 0
	Color 255,255,255
	Text 20,20,"Leben: " + PL
	
	PX = PX + Cos(PW)*PS
	PY = PY + Sin(PW)*PS
	DrawImage imgP(PW), PX, PY
End Function

Function moveGhost()
	count = 0
	Selection = 0
	Temp = 101
	For G.Ghosts = Each Ghosts
		If Temp > G\Entf Then
			Temp = G\Entf
			Selection = count
		EndIf
		count = count +1
	Next
	G.Ghosts = First Ghosts
	If G.Ghosts <> Null Then
		For I = 1 To Selection
			G = After G
		Next
		If G\Attaced = 0 Then G\Attaced = 2
	EndIf
	
	For G.Ghosts = Each Ghosts
		If G\Entf < 100 Then
			If G\S = G\SS Then G\W[0] = berechneWinkel(G\X, G\Y, PX, PY)
			If PA = 1 Then
				If PZ < PZA  And G\Attaced = 2 Then G\Attaced = 1
				If G\Attaced = 1 Then
					PS = -1.0
					G\S = -2.8
					G\Leben = G\Leben - (Schleifenzeit*0.06)
					PW = berechneWinkel(PX, PY, G\X, G\Y)
					PW = PW + Rand(-10,10)
					If PW > 360 Then PW = PW - 360
					If PW < 0 Then PW = 360 + PW
					Color 255,255,255
					Line G\X, G\Y, PX, PY
					G\W[0] = PW
				EndIf
			EndIf
		Else
			If G\T > G\Time Then
				G\W[0] = Rand(1, 359)
				G\Time = Rand(2000, 3000)
				G\T = 0
			EndIf
		EndIf
		If PA = 0 Then
			G\Attaced = 0
			PZ = 0
		EndIf
		If G\Attaced = 1 Then PZ = PZ + 1
		If (G\Entf < 50 Or G\Entf > 200) And PA = 0 Then G\S = G\SS
		If ImagesOverlap(imgP(0), PX, PY, imgG(0), G\X, G\Y) Then PL = PL - (Schleifenzeit*0.01)
		G\X = G\X + Cos(G\W[0])*(G\S)
		G\Y = G\Y + Sin(G\W[0])*(G\S)
		G\Entf = berechneEntf(G\X, G\Y, PX, PY, G\W[0])
		G\T = G\T + Schleifenzeit
		
		For I = 0 To 4
			G\BT[I] = G\BT[I] + Schleifenzeit
			If G\BT[I] > G\BTT[I] Then
				G\BX[I] = G\X  :G\BY[I] = G\Y + Rand(-3,3)
				G\BW[I] = Rand(3,8)
				G\BTT[I] = Rand(500,2000)
				G\BT[I] = 0
			EndIf
			Color 75, 29, 181
			Oval G\BX[I], G\BY[I], G\BW[I], G\BW[I]
		Next
		
		DrawImage imgG(G\W[0]), G\X, G\Y
		If G\Leben < 0 Then
			Delete G
			If Gp > 1 Then Gt = Gt + 1
			If Gp = 3 Then Gt2 = Gt2 + 3000
		EndIf
	Next
End Function

Function Menue()
	Local MenueS$[4]
	Local Game$[2]
	Local Extras$[2]
	MenueS[0] = "Spiele"
	MenueS[1] = "Extras"
	MenueS[2] = "Credits"
	MenueS[3] = "Beenden"
	Game[0] = "berlebe lange!"
	Game[1] = "Zerstre!"
	Game[2] = "Mehr Zeit!"
	Extras[0] = "Mapeditor"
	Extras[1] = "Map verwerfen"
	Extras[2] = "Schatten?"
	
	Color 255,255,255
	
	If Mp = 0 Then
		Grenze = 4
		For I = 0 To 3
			Text 100, 100+(I+1)*50, MenueS[I]
		Next
		If KeyHit(28) Then
			Mp = Mn
			Mn = 1
		EndIf
		DrawImage imgG(90), 75, 108+(Mn*50)
	EndIf
	If Mp = 1 And Gp = 0 Then
		Grenze = 3
		For I = 0 To 2
			Text 100, 100+(I+1)*50, Game[I]
		Next
		If KeyHit(28) Then
			Gp = Mn
			Mn = 1
			loadMap()
		EndIf
		Color 100,100,100
		Oval 300,400,50,50
		Color 255,255,255
		Text 300,400,"Best:"
		Text 320,420,B[Mn]
		DrawImage imgG(90), 75, 108+(Mn*50)
	EndIf
	If Mp = 2 And Ep = 0 Then
		Grenze = 3
		For I = 0 To 2
			Text 100, 100+(I+1)*50, Extras[I]
		Next
		If KeyHit(28) Then
			Ep = Mn
			Mn = 1
		EndIf
		DrawImage imgG(90), 75, 108+(Mn*50)
	EndIf
	If KeyHit(200) Then Mn = Mn - 1
	If Mn < 1 Then Mn = Grenze
	If KeyHit(208) Then Mn = Mn + 1
	If Mn > Grenze Then Mn = 1
End Function

Function Games()
	HidePointer
	T = T + Schleifenzeit
	If T > TT Then
		erstelleGhost()
		TT = Rnd(3000,8000)
		T = 0
	EndIf
	
	Color 255,255,255
	If Gp = 1 Then
		Text 300, 50, Gt/1000 + " Sekunden"
		Gt = Gt + Schleifenzeit
	EndIf
	If Gp = 2 Then
		Text 300, 50, Gt + " eingesaugt"
	EndIf
	If Gp = 3 Then
		Text 300, 50, Gt2/1000 + " Sekunden   " + Gt + " eingesaugt"
		Gt2 = Gt2 - Schleifenzeit
	EndIf
End Function

Function Extras()
	If Ep = 1
		ShowPointer
		FloorX = 32*(MX/32)+16
		FloorY = 32*(MY/32)+16
		DrawImage imgF(1), FloorX, FloorY
		If MH Then
			Bl.Bloecke = New Bloecke
			Bl\X = FloorX
			Bl\Y = FloorY
		EndIf
		If MH2 Then
			For Bl.Bloecke = Each Bloecke
				If ImageRectOverlap(imgF(1), Bl\X, Bl\Y, MX, MY, 1,1) Then Delete Bl
			Next
		EndIf
	EndIf
	If Ep = 2
		E = 0
		Ep = 0
		For Bl.Bloecke = Each Bloecke
			Delete Bl
		Next
	EndIf
	If S Mod 2 = 1
		DrawImage imgL, PX-100, PY-100
		Color 1,1,1
		Rect 0,0,640,PY-100
		Rect 0,PY-100,PX-100,200
		Rect 0,PY+100,640,480-PY+100
		Rect PX+100,PY-100,640-PX+100,200
	EndIf
End Function

Function Credits()
	Text 300, 200, "Program by Severin Bauer"
	PL = 100
	If C = 0 Then
		For Bl.Bloecke = Each Bloecke
			Delete Bl
		Next
		C = 1
		For I = 0 To 20
			erstelleGhost()
		Next
	EndIf
End Function

.arena
Data 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
Data 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1