Graphics3D 400,220,0,2
SetBuffer BackBuffer()

Global tot,score1,score2

Type punkt
 Field id
 Field x#
 Field y#
End Type
Type connect
 Field id
 Field p1.punkt
 Field p2.punkt
 Field cleft.connect
 Field cright.connect
 Field vx#
 Field vy#
End Type

Type blood
 Field x#
 Field y#
 Field vx#
 Field vy#
End Type

Type star
 Field phi#
 Field x#
 Field y#
 Field vx#
 Field vy#
End Type

Type gegner
 Field x#
 Field y#
 Field vx#
 Field vy#
 Field att
 Field phi#
 Field i
 Field timer
 Field t#
 Field gotflag
End Type

makegame()

Function makegame()
Delete Each punkt
Delete Each connect
Delete Each gegner
Delete Each star
Delete Each blood

px#=16
py#=180
vx#=0
vy#=0
 vx0#=2.5
 vy0#=8.5

maxpt=13
p.punkt=New punkt
 p\id=1 : p\x=0 : p\y=200
p.punkt=New punkt
 p\id=2 : p\x=100 : p\y=200
p.punkt=New punkt
 p\id=3 : p\x=200 : p\y=100
p.punkt=New punkt
 p\id=4 : p\x=300 : p\y=100
p.punkt=New punkt
 p\id=5 : p\x=400 : p\y=200
p.punkt=New punkt
 p\id=6 : p\x=800 : p\y=200
p.punkt=New punkt
 p\id=7 : p\x=900 : p\y=100
p.punkt=New punkt
 p\id=8 : p\x=1000 : p\y=200
p.punkt=New punkt
 p\id=9 : p\x=1400 : p\y=200
p.punkt=New punkt
 p\id=10 : p\x=1500 : p\y=100
p.punkt=New punkt
 p\id=11 : p\x=1600 : p\y=100
p.punkt=New punkt
 p\id=12 : p\x=1700 : p\y=200
p.punkt=New punkt
 p\id=13 : p\x=1800 : p\y=200
For i=1 To maxpt-1
 addconnect(i,i,i+1)
Next

For i=1 To 15
 g.gegner=New gegner
  g\x=1550+Rand(-100,100)
  g\y=75
  g\vx=-2.5
  g\gotflag=2
Next
For i=1 To 10
 g.gegner=New gegner
  g\x=1550+Rand(-200,200)
  g\y=75
  g\vx=-2.5
Next

flagpole1#=250
flag1x#=250
flag1y#=100
 gotflag=0

flagpole2#=1550
flag2x#=1550
flag2y#=100

createtime=MilliSecs()

While Not KeyHit(1)
If MilliSecs()-frametime>17 Then
UpdateWorld : RenderWorld
 key200=KeyHit(200)

Text GraphicsWidth()/2-Len(score1+" : "+score2)*4,15,score1+" : "+score2

Line flag1x,flag1y,flag1x,flag1y-25
 Line flag1x,flag1y-25,flag1x+10,flag1y-20
 Line flag1x,flag1y-15,flag1x+10,flag1y-20
Line flag2x,flag2y,flag2x,flag2y-25
 Line flag2x,flag2y-25,flag2x+10,flag2y-20
 Line flag2x,flag2y-15,flag2x+10,flag2y-20

Color 255,0,0
For b.blood=Each blood
 Oval b\x-1,b\y-1,2,2
 If b\y<=220 Then
  b\x=b\x+b\vx
  b\vy=b\vy+0.2
  b\y=b\y+b\vy
 Else
  Delete b.blood
 EndIf
Next

Color 255,255,255

Oval px-2,py-10,4,10
For s.star=Each star
 For w=s\phi To s\phi+360 Step 45
  Line s\x,s\y,s\x+Cos(w)*5,s\y+Sin(w)*5
 Next
 If s\y<=220
  s\phi=s\phi+2
  s\x=s\x+s\vx
  s\vy=s\vy+0.2
  s\y=s\y+s\vy
 Else
  Delete s.star
 EndIf
Next

If vx>0 Then dir=0
If vx<0 Then dir=1
startv=Abs(vx)+2
If KeyHit(57) Then
 If MilliSecs()-startime>750 Then
  s.star=New star
   s\x=px
   s\y=py-5
   s\vx=startv*(-2*dir+1)
   s\vy=-2
  startime=MilliSecs()
 EndIf
EndIf

 If RectsOverlap(px-2,py-10,4,10,flag2x,flag2y-25,2,25) Then gotflag=1
 If gotflag=1 Then
  flag2x=px
  flag2y=py
 EndIf

 If flagx1=flagpole1 And Abs(flagx2-flagx1)<15 Then score1=score1+1 : makegame()
 If flagx2=flagpole2 And Abs(flagx2-flagx1)<15 Then score2=score2+1 : makegame()
 If py>220 Then score2=score2+1 : makegame()

If MilliSecs()-createtime>4000 Then
 g.gegner=New gegner
  g\x=flagpole1+Rand(-100,100)
  g\y=75
  g\vx=1
 createtime=MilliSecs()
EndIf

For g.gegner=Each gegner
 If g\gotflag=1 Then
  g\vx=Abs(g\vx)
 ElseIf g\gotflag=2 Then
  If gotflag=1 Then g\gotflag=0
  If g\x>flagpole2+175 Or g\x<flagpole2-175 Then g\vx=-g\vx
 Else
  g\vx=Abs(g\vx)*Sgn(flag1x-g\x)
 EndIf
 p.punkt=Last punkt : If g\vx>0 And g\x+g\vx>p\x Then g\vx=-g\vx
 g\t=1 : g\vy=g\vy+0.5
 For c.connect=Each connect
  v1#=c\p2\x-c\p1\x
  v2#=c\p2\y-c\p1\y
  d#=v1*c\p1\y-v2*c\p1\x
  hnf#=Abs((g\x*v2-g\y*v1+d)/Sqr(v1^2+v2^2))
  If hnf<1 Then
   If Abs(v1)>0 Then
    t1#=(g\x-c\p1\x)/v1
    t2#=(g\y-c\p1\y)/v2
     If v2=0 Then t2=t1
    If t1>=0 And t1<=1 And t2>=0 And t2<=1 And Abs(t1-t2)<0.1 Then
     yerw#=c\p1\y+(t1+t2)/2.*v2
     If g\y<yerw Then
      g\vx=(vx0-.5)*Sgn(g\vx)
      g\vy=g\vx*v2/v1
     EndIf
    EndIf
   EndIf
  EndIf
 Next
 For c.connect=Each connect
  x1#=c\p1\x : y1#=c\p1\y
  v1#=c\p2\x-c\p1\x : v2#=c\p2\y-c\p1\y
  k#=(g\x*g\vy-g\y*g\vx+g\vx*y1-g\vy*x1)/(v1*g\vy-v2*g\vx)
  t#=(g\x*v2-g\y*v1+v1*y1-v2*x1)/(v1*g\vy-v2*g\vx)
  If t>=0 And t<=1 And k>=0 And k<=1 Then
   If t<g\t Then
    g\t=t : g\vy=0
   EndIf
  EndIf
 Next
 g\x=g\x+(g\t-0.2)*g\vx
 g\y=g\y+(g\t-0.2)*g\vy

 Oval g\x-2,g\y-10,4,10
 If RectsOverlap(g\x-2,g\y-10,4,10,flag1x-1,flag1y-25,2,25) And flaggone=0 Then g\gotflag=1 : flaggone=1

 If g\gotflag=1 Then
  flag1x=g\x
  flag1y=g\y
 EndIf

 gdir=-.5*Sgn(g\vx)+.5

 ex#=g\x+Cos(90-g\phi*Sgn(g\vx))*15
 ey#=g\y-5-Sin(90-g\phi*Sgn(g\vx))*15
  p1x#=g\x
  p1y#=g\y-5
 v1#=ex-p1x
 v2#=ey-p1y
  p2x#=px
  p2y#=py-10
 v3#=0
 v4#=10

 zx#=-(p1x*v2*v3-(p1y*v3+p2x*v4-p2y*v3)*v1)/(v1*v4-v2*v3)
 zy#=-(p1x*v2*v4-p1y*v1*v4-(p2x*v4-p2y*v3)*v2)/(v1*v4-v2*v3)
  t1#=-(p1x*v4-p1y*v3-p2x*v4+p2y*v3)/(v1*v4-v2*v3) ;p1+t*v
  k1#=-(p1x*v2-p1y*v1-p2x*v2+p2y*v1)/(v1*v4-v2*v3) ;p2+k*v

 If t1>=0 And t1<=1 And k1>=0 And k1<=1 Then
  score2=score2+1 : makegame()
 EndIf

 Line g\x,g\y-5,ex,ey
 If g\att=0 Then
  If Abs(g\x-px)<20 And Sgn(px-g\x)=Sgn(g\vx) Then g\att=1
 ElseIf g\att=1 Then
  g\phi=g\phi+8
  If Abs(g\phi)>=90 Then g\att=2
 ElseIf g\att=2 Then
  g\phi=g\phi-2
  If g\phi<=0 Then g\phi=0 : g\att=0
 EndIf

 For s.star=Each star
  If RectsOverlap(s\x-5,s\y-5,10,10,g\x-2,g\y-10,4,10) Then
   s\vx=0
   For w=0 To 15
    b.blood=New blood
     b\x=g\x
     b\y=g\y-10
     b\vx=Rnd(-1,1)
     b\vy=Rnd(-2,-4)
   Next
    If g\gotflag=1 Then
     flag1x=flagpole1 : flag1y=100 : flaggone=0
    EndIf
   Delete g.gegner : Exit
  EndIf
 Next

 If g.gegner<>Null Then
  If g\y>220 Then
   If g\gotflag=1 Then flag1x=flagpole1 : flag1y=100 : flaggone=0
   Delete g.gegner
  EndIf
 EndIf
Next

vy=vy+0.5
If jump<>0 Then
 If KeyDown(203) And vx>-(vx0-0.1) Then vx=vx-(vx0/10.)
 If KeyDown(205) And vx<(vx0-0.1) Then vx=vx+(vx0/10.)
 If jump=1 And key200 Then vy=-vy0 : jump=2
EndIf

For c.connect=Each connect
If c<>Null And c\p1<>Null And c\p2<>Null Then
 Line c\p1\x,c\p1\y,c\p2\x,c\p2\y

 If jump=0 Then
  v1#=c\p2\x-c\p1\x
  v2#=c\p2\y-c\p1\y
  d#=v1*c\p1\y-v2*c\p1\x
  hnf#=Abs((px*v2-py*v1+d)/Sqr(v1^2+v2^2))
  If hnf<1 Then
   If Abs(v1)>0 Then
    t1#=(px-c\p1\x)/v1
    t2#=(py-c\p1\y)/v2
     If v2=0 Then t2=t1
    If t1>=0 And t1<=1 And t2>=0 And t2<=1 And Abs(t1-t2)<0.1 Then
     If key200 Then
      jump=1
      vx=vx0*(KeyDown(205)-KeyDown(203))
      vy=-vy0
     Else
      yerw#=c\p1\y+(t1+t2)/2.*v2
      If py<yerw Then
       vx=vx0*(KeyDown(205)-KeyDown(203))
       vy=vx*v2/v1
      EndIf
     EndIf
    EndIf
   EndIf
  EndIf
 EndIf

EndIf
Next

coll=0 : t0#=1
For c.connect=Each connect
If c<>Null And c\p1<>Null And c\p2<>Null Then
 x1#=c\p1\x
 y1#=c\p1\y
 v1#=c\p2\x-c\p1\x
 v2#=c\p2\y-c\p1\y

 k#=(px*vy-py*vx+vx*y1-vy*x1)/(v1*vy-v2*vx)
 t#=(px*v2-py*v1+v1*y1-v2*x1)/(v1*vy-v2*vx)

 If t>=0 And t<=1 And k>=0 And k<=1 And t<t0 Then
  t0=t : coll=1

  If jump=1 And vy<=0 Then
   py=py+2 : vy=Abs(vy)
   If jump<>2 Then jump=1
  Else
   jump=0
  EndIf

 EndIf

EndIf
Next

If coll=0 Then
 py=py+vy
 If vx>0 Then
  If px<GraphicsWidth()/2 Then
   px=px+vx
  Else
   p.punkt=Last punkt
   If p\x>400 Then
    For p.punkt=Each punkt
     p\x=p\x-vx
    Next
    For g.gegner=Each gegner
     g\x=g\x-vx
    Next
    flag1x=flag1x-vx
    flag2x=flag2x-vx
    flagpole1=flagpole1-vx
    flagpole2=flagpole2-vx
   Else
    px=px+vx
   EndIf
  EndIf
 Else
  If px>GraphicsWidth()/2 Then
   px=px+vx
  Else
   p.punkt=First punkt
   If p\x<0 Then
    For p.punkt=Each punkt
     p\x=p\x-vx
    Next
    For g.gegner=Each gegner
     g\x=g\x-vx
    Next
    flag1x=flag1x-vx
    flag2x=flag2x-vx
    flagpole1=flagpole1-vx
    flagpole2=flagpole2-vx
   Else
    px=px+vx
   EndIf
  EndIf
 EndIf
Else
 If vx>0 Then
  If px<GraphicsWidth()/2 Then
   px=px+(t0-0.2)*vx
   py=py+(t0-0.2)*vy-0.2
   vx=0 : vy=0
  Else
   For p.punkt=Each punkt
    p\x=p\x-(t0-0.2)*vx
   Next
   For g.gegner=Each gegner
    g\x=g\x-(t0-0.2)*vx
   Next
   flag1x=flag1x-(t0-0.2)*vx
   flag2x=flag2x-(t0-0.2)*vx
   flagpole1=flagpole1-(t0-0.2)*vx
   flagpole2=flagpole2-(t0-0.2)*vx
   py=py+(t0-0.2)*vy-0.2
   vx=0 : vy=0
  EndIf
 Else
  If px>GraphicsWidth()/2 Then
   px=px+(t0-0.2)*vx
   py=py+(t0-0.2)*vy-0.2
   vx=0 : vy=0
  Else
   For p.punkt=Each punkt
    p\x=p\x-(t0-0.2)*vx
   Next
   For g.gegner=Each gegner
    g\x=g\x-(t0-0.2)*vx
   Next
   flag1x=flag1x-(t0-0.2)*vx
   flag2x=flag2x-(t0-0.2)*vx
   flagpole1=flagpole1-(t0-0.2)*vx
   flagpole2=flagpole2-(t0-0.2)*vx
   py=py+(t0-0.2)*vy-0.2
   vx=0 : vy=0
  EndIf
 EndIf
EndIf

frametime=(MilliSecs() And $7fFFffFF)
Flip 0 : Cls
EndIf
Wend : End
End Function

Function addconnect(connr,id1,id2)
 c.connect=New connect
  c\id=connr
  For p.punkt=Each punkt
   If p\id=id1 Then
    c\p1.punkt=p.punkt
   EndIf
   If p\id=id2 Then
    c\p2.punkt=p.punkt
   EndIf
  Next
End Function