Graphics 800,600,0,2
AppTitle "Der Stinker"
SeedRnd MilliSecs()
SetFont LoadFont("Arial",16)
Text 400,30,"Erstelle Daten",1
Flip 0

;berschrift
logo=CreateImage(65,16)
buff logo
Text 0,0,"Der Stinker"
For x=0 To 64
For y=0 To 15
If ReadPixel(x,y)<>$FF000000 Then
WritePixel x,y,Rand(130,180) Shl 16+Rand(130,180) Shl 8+Rand(0,40)
EndIf
Next
Next
ResizeImage logo,260,64

;Spieler
Dim p(119)
p(0)=CreateImage(32,32)
MidHandle p(0)
buff p(0)
Color 100,100,200
Oval 5,0,22,32
Color 10,10,10
Oval 10,8,12,16
Color 80,80,160
Oval 16,2,10,4
Oval 16,26,10,4
For i=1 To 119
p(i)=CopyImage(p(0))
RotateImage p(i),i*3
Next
Global px#,py#,pw,pdir

;TileMap
Global tiles=CreateImage(32,32,6)
buff tiles,0
For x=0 To 31
For y=0 To 31
WritePixel x,y,Rand(0,50) Shl 16+Rand(130,200) Shl 8+Rand(0,80)
Next
Next

buff tiles,1
For x=0 To 31
For y=0 To 31
c=Rand(30,100)
WritePixel x,y,c Shl 16+c Shl 8+c
Next
Next

buff tiles,2
For x=0 To 31
For y=0 To 31
c=Rand(100,200)
WritePixel x,y,c Shl 16+c Shl 8+c
Next
Next

;Haltestellentafel
buff tiles,3
Color 20,200,20
Oval 0,0,32,32
Color 200,200,20
Oval 3,3,26,26
Color 20,200,20
Text 16,16,"H",1,1

;Essen
buff tiles,4
For i=0 To 8
Color 50+i*15,0,0
Oval 4+i,4+i,20-i*2,20-i*2
Next

;Messer
buff tiles,5
For i=0 To 2
Color 100+i*20,100+i*20,100+i*20
Line i,i,20-i,20-1
Next

;Gegner
Type geg
Field x#,y#,w
Field typ
Field timer,hunt,item
End Type
Global g.geg
Dim gimg(3,119)
For i=0 To 3
gimg(i,0)=CreateImage(32,32)
MidHandle gimg(i,0)
buff gimg(i,0)
r=Rand(20,255):gg=Rand(20,255):b=Rand(20,255)
Color r,gg,b
Oval 8,0,16,32
Color 10,10,10
Oval 11,8,12,16
Color r-20,gg-20,b-20
Oval 16,2,10,4
Oval 16,26,10,4
For j=1 To 119
gimg(i,j)=CopyImage(gimg(i,0))
RotateImage gimg(i,j),j*3
Next
Next

;Frze
Type furz
Field x#,y#
Field timer
Field img
Field w,zielw
End Type
Global furz.furz
Dim furzimg(4)
For i=0 To 4
s=Rand(5,20)
furzimg(i)=CreateImage(s,s)
MidHandle furzimg(i)
buff furzimg(i)
Color 100,100,10
Oval 0,0,s,s
Next

;Items
Type item
Field x,y,typ
End Type
Global item.item

timer=CreateTimer(50)

Dim map(0,0)
Global mapw,maph
Global zielx,ziely
Global bg
Global mx,my,mhit

mask=CreateImage(800,600)

SetBuffer BackBuffer()

.menu
Color 255,255,255
mapnr=1
leben=150
gv#=1.3
view=0
Repeat
;Frze zur Verzierung
If Rand(0,8)=1 Then NewFurz(Rand(0,780),Rand(0,580))

For furz=Each furz
DrawImage furzimg(furz\img),furz\x,furz\y
furz\x=furz\x+Cos(furz\w)*.3
furz\y=furz\y+Sin(furz\w)*.3
furz\timer=furz\timer+1
If furz\timer>400 Then Delete furz
Next

;GUI
mx=MouseX():my=MouseY()
mhit=MouseHit(1)

mapnr=button(400,100,"Map whlen: "+mapnr,mapnr,1,1,4)
view=button(400,130,"Eingeschrnkte Sicht: "+view,view,1,0,1)
leben=button(400,160,"Lebenspunkte zu Spielstart: "+leben,leben,10,50,200)
gv=button(400,190,"Gegner-Geschwindigkeit: "+gv,gv,.1,1,1.8)
If button(400,220,"Standardeinstellungen",0,1,1,1) Then Goto menu
If button(400,300,"Spiel starten",0,1,0,1) Then
LoadMap mapnr
Goto game
EndIf
If button(400,380,"Spiel beenden",0,1,0,1) Then End

DrawImage logo,270,10

Text 10,580,"Ein Spiel von Christoph Mach aka Eingeproggt anlsslich des BCC#20"

Flip 0:Cls
WaitTimer timer
Until KeyHit(1)
End

.game
Delete Each furz
vorrat=200
start=MilliSecs()
Repeat
;Map
DrawBlock bg,0,0

;Steuerung
If KeyDown(200) Then
pdir=1
checkPlayer(1)
EndIf
If KeyDown(208) Then
pdir=0
checkPlayer(1)
EndIf
If KeyDown(203) Then
pw=pw-2
If pw<0 Then pw=358
checkPlayer(0)
EndIf
If KeyDown(205) Then
pw=(pw+2) Mod 360
checkPlayer(0)
EndIf
If KeyDown(57) And vorrat>0 Then
vorrat=vorrat-1
NewFurz(px,py)
EndIf

;Spieler zeichnen
DrawImage p(pw/3),px,py

If (MilliSecs()-start) Mod 400<200 And MilliSecs()-start<3000 Then Rect px-16,py-16,32,32,0

;Gegner steuern&Zeichnen
For g=Each geg
If g\timer<=0 Then
;Bewegung
If check(g\x+Cos(g\w)*gv,g\y+Sin(g\w)*gv,g\w,16,8) Then
g\x=g\x+Cos(g\w)*gv
g\y=g\y+Sin(g\w)*gv
Else
g\w=Rand(0,7)*45
EndIf

x=g\x-px:y=g\y-py
g\hunt=Sqr(x*x+y*y)<100

If g\hunt Then
If g\typ<2 Then
;Vor Spieler flchten
g\w=ATan2(g\y-py,g\x-px)
Else
If g\item Then
;Spieler verfolgen
xp=Cos(pw+90)*8
yp=Sin(pw+90)*8
xg=Cos(g\w+90)*7
yg=Sin(g\w+90)*7
If cc(px-xp,py-yp,7,g\x+xg,g\y+yg,7) Or cc(px+xp,py+yp,7,g\x-xg,g\y-yg,7) Or cc(px-xp,py-yp,7,g\x-xg,g\y-yg,7) Or cc(px+xp,py+yp,7,g\x+xg,g\y+yg,7) Then
leben=leben-1
EndIf
g\w=ATan2(g\y-py,g\x-px)+180
Else
g\w=ATan2(g\y-py,g\x-px)
EndIf
EndIf
Else
;Dumm herum rennen
If g\timer<Rand(-250,-150) Then
g\timer=0
g\w=Rand(0,7)*45
EndIf
EndIf

;Winkelbegrenzung
If g\w<0 Then g\w=360+g\w
If g\w>359 Then g\w=g\w-360
EndIf
g\timer=g\timer-1
DrawImage gimg(g\typ,Floor(g\w/3)),g\x,g\y
Next

;Items
For item=Each item
DrawImage tiles,item\x,item\y,item\typ+4
If cc(item\x+10,item\y+10,10,px,py,10) Then
If item\typ Then
leben=leben-20
Else
vorrat=vorrat+50
If vorrat>600 Then vorrat=600
EndIf
Delete item
EndIf
Next

;Frze updaten
For furz=Each furz
DrawImage furzimg(furz\img),furz\x,furz\y
furz\x=furz\x+Cos(furz\w)*.3
furz\y=furz\y+Sin(furz\w)*.3
furz\timer=furz\timer+1
If map(f(furz\x),f(furz\y))=2 Or furz\timer>400 Then
Delete furz
Else
;Auf Gegner-Koll prfen
w=ImageWidth(furzimg(furz\img))/2
For g=Each geg
If cc(furz\x,furz\y,w,g\x,g\y,8) And g\timer<0 Then
Delete furz
g\timer=200
If g\item Then
item=New item
item\x=f(g\x)*32
item\y=f(g\y)*32
item\typ=g\typ/2
EndIf
g\item=0
Exit
EndIf
Next
EndIf
Next

;Maske
If view Then
buff mask
Color 10,10,10
Rect 0,0,800,600
Color 0,0,0
Oval px-150,py-150,300,300
SetBuffer BackBuffer()
DrawImage mask,0,0
EndIf

;HUD
Color 100,100,100
Rect 0,570,800,30
Color 50,200,50
Rect 1,571,vorrat,28
Rect 799-leben,571,leben,28
Color 255,255,255
Rect 0,570,600,30,0
Rect 600,570,200,30,0
Text 10,578,"Blhungen"
Text 700,578,"Lebensenergie"

;Spielende
If leben<0 Then ende 0:Exit
If px>zielx*32 And px<zielx*32+32 And py>ziely*32 And py<ziely*32+32 Then
ende 1
Exit
EndIf

Flip 0 : Cls
WaitTimer timer
Until KeyHit(1)
Delete Each furz
Delete Each geg
Delete Each item
FreeImage bg
FlushKeys
Goto menu

Function checkPlayer(flag)
xold=px
If pdir Then
pw2=pw
Else
pw2=(pw+180) Mod 360
EndIf
If check(px+Cos(pw2),py,pw2,16,11) Then
If flag Then px=px+Cos(pw2)
Else
px=px-Cos(pw2)/2
EndIf
If check(xold,py+Sin(pw2),pw2,16,11) Then
If flag Then py=py+Sin(pw2)
Else
py=py-Sin(pw2)/2
EndIf
End Function

Function check(x,y,w,a,b)
w=w+90
For i=180 To 340 Step 20
xx=Cos(i)*a
yy=Sin(i)*b
r=Sqr(xx*xx+yy*yy)
xx=Cos(i+w)*r
yy=Sin(i+w)*r
If map(f(x+xx),f(y+yy))=2 Then Return 0
Next
Return 1
End Function

Function LoadMap(num)
;Daten laden
If num=1 Then Restore map1
If num=2 Then Restore map2
If num=3 Then Restore map3
If num=4 Then Restore map4
Read mapw:Read maph
Dim map(mapw-1,maph-1)
For y=0 To maph-1
For x=0 To mapw-1
Read map(x,y)
Next
Next
Read zielx:Read ziely
Read px:Read py

;Map-Bild
bg=CreateImage(mapw*32,maph*32)
buff bg
For i=0 To mapw-1
For j=0 To maph-1
DrawBlock tiles,i*32,j*32,map(i,j)
Next
Next
DrawImage tiles,zielx*32,ziely*32,3
SetBuffer BackBuffer()

;Gegner erstellen
For i=0 To (mapw*maph)/20
g=New geg
g\item=1
g\typ=Rand(0,3)
g\w=Rand(0,359)
Repeat
g\x=Rand(1,mapw-2)
g\y=Rand(1,maph-2)
tmpx=g\x*32+16
tmpy=g\y*32+16
Until map(g\x,g\y)<>2 And Sqr((px-tmpx)*(px-tmpx)+(py-tmpy)*(py-tmpy))>150
g\x=tmpx:g\y=tmpy
Next

End Function

Function f(val#)
Return Floor(val/32)
End Function

Function buff(img,x=0)
SetBuffer ImageBuffer(img,x)
End Function

Function NewFurz(x,y)
furz=New furz
furz\x=x
furz\y=y
furz\timer=Rand(0,200)
furz\img=Rand(0,4)
furz\w=Rand(0,359)
End Function

Function ende(flag)
Color 100,100,100
Rect 220,270,360,60,1
Color 255,255,255
Rect 220,270,360,60,0
If flag Then
Text 400,290,"Der Stinker kommt sicher nach Hause! Gratulation!",1,1
Else
Text 400,290,"Der Stinker ist abgestunken :(",1,1
EndIf
Text 400,310,"Taste drcken, um ins Men zu gelangen",1,1
Flip 0
FlushKeys
WaitKey
End Function

Function button#(x,y,txt$,val#,st#,min#,max#)
w=StringWidth(txt$)+10
h=FontHeight()+6
If mx>x-w/2 And mx<x+w/2 And my>y-h/2 And my<y+h/2 Then
Color 160,160,160
If mhit Then
val=val+st
If val>max Then val=min
EndIf
Else
Color 100,100,100
EndIf
Rect x-w/2,y-h/2,w,h
Color 255,255,255
Rect x-w/2,y-h/2,w,h,0
Text x,y,txt$,1,1
Return val
End Function

Function cc(x1,y1,r1,x2,y2,r2) ;Circles Collide
Return (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)<(r1+r2)*(r1+r2)
End Function

.map1
Data 19,15
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 2,1,1,1,1,1,1,1,0,2,0,1,1,1,1,1,1,1,2
Data 2,1,1,1,1,1,1,1,0,2,0,1,1,1,1,1,1,1,2
Data 2,1,1,0,0,0,1,1,0,2,0,1,1,0,0,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,2,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,2,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,2,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,2,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,2,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,2,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,2,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,0,0,0,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,1,1,1,1,1,0,2,0,1,1,2
Data 2,1,1,0,2,0,1,1,1,1,1,1,1,0,2,0,1,1,2
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 17,13
Data 2.5*32,12.5*32

.map2
Data 20,18
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 2,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,2
Data 2,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,2
Data 2,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,0,2
Data 2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
Data 2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,2
Data 2,0,0,2,0,0,0,0,0,2,2,0,0,0,0,0,2,0,0,2
Data 2,0,0,2,0,0,0,0,0,2,2,0,0,0,0,0,2,0,0,2
Data 2,0,0,2,0,0,0,0,0,2,2,0,0,0,0,0,2,0,0,2
Data 2,2,2,2,0,0,2,2,2,2,2,2,2,2,0,0,2,2,2,2
Data 2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,2,2,2,2
Data 2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,2,2,2,2
Data 2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,2,2,2,2
Data 2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,2,2,2,2
Data 2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,2,2,2,2
Data 2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,2,2,2,2
Data 2,2,2,2,0,0,0,0,0,2,2,0,0,0,0,0,2,2,2,2
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 7,15
Data 12.5*32,15.5*32

.map3
Data 16,15
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2
Data 2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2
Data 2,0,0,2,0,0,2,2,2,2,2,2,2,0,0,2
Data 2,0,0,2,0,0,2,0,0,0,0,0,2,0,0,2
Data 2,0,0,2,0,0,2,0,0,0,0,0,2,0,0,2
Data 2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2
Data 2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2
Data 2,0,0,2,0,0,2,2,2,2,0,0,2,0,0,2
Data 2,0,0,2,0,0,0,0,0,0,0,0,2,0,0,2
Data 2,0,0,2,0,0,0,0,0,0,0,0,2,0,0,2
Data 2,0,0,2,2,2,2,2,2,2,2,2,2,0,0,2
Data 2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
Data 2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 8,7
Data 1.5*32,1.5*32

.map4
Data 20,18
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,2,2,0,2,2,2,2,2,1,1,2,2,2,2,2,0,2,2,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,0,0,0,0,0,2
Data 2,2,2,0,2,2,2,2,2,1,1,2,2,2,2,2,0,2,2,2
Data 2,0,0,0,0,0,2,0,0,1,1,0,0,2,1,1,1,1,1,2
Data 2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2
Data 2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2
Data 2,0,0,0,0,0,2,0,0,0,0,0,0,2,1,1,1,1,1,2
Data 2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
Data 18,16
Data 1.5*32,1.5*32
;~IDEal Editor Parameters:
;~C#Blitz 3D